﻿using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Intercom
{
    public partial class FrmIntercom : Form
    {
        [DllImport("intercom.dll")] private static extern int icInit(IntPtr hwnd);
        [DllImport("intercom.dll")] private static extern int icSendMsg(int cmd, string pdest);
        [DllImport("intercom.dll")] private static extern int icGetMsg(ref int cmd, [In, Out] byte[] pdest);
        [DllImport("intercom.dll")] private static extern int icBusyStatus(bool status);
        [DllImport("intercom.dll")] private static extern int icEnd();

        private IntPtr FrmHandle = IntPtr.Zero;

        public FrmIntercom()
        {
            InitializeComponent();
        }

        private void BtnSendMessageClick(object sender, EventArgs e)
        {
            icSendMsg(int.Parse(txtMacroNumber.Text), txtMacroData.Text);
        }

        private void FrmIntercomFormClosed(object sender, FormClosedEventArgs e)
        {
            tmrReceiveMessage.Stop();
            icEnd();
        }

        private void FrmIntercomLoad(object sender, EventArgs e)
        {
            var temp = icInit(Handle);

            if (temp != 0 && temp != 183) return;

            FrmHandle = Handle;
            tmrReceiveMessage.Start();
        }

        private void TmrReceiveMessageTick(object sender, EventArgs e)
        {
            if(FrmHandle == IntPtr.Zero) return;

            var bytMsg = new byte[128];
            var intMsg = 0;

            var temp = icGetMsg(ref intMsg, bytMsg);

            switch(temp)
            {
                case 0:
                    var strNumbers = System.Text.Encoding.ASCII.GetString(bytMsg).Split(',');
                    var x = double.Parse(strNumbers[0]);
                    var y = double.Parse(strNumbers[1]);

                    var strDiamond = "LINE \n" +
                                     (x - 100) + "," + y + " \n" +
                                     x + "," + (y - 100) + " \n" +
                                     (x + 100) + "," + y + " \n" +
                                     x + "," + (y + 100) + " \n" +
                                     (x - 100) + "," + y + " \n\n" +
                                     "ENDM";

                    icSendMsg(20, strDiamond); 

                    break;
                default:
                    //No Message
                    break;
            }
        }
    }
}
